Index: /palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3967)
+++ /palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3968)
@@ -1038,20 +1121,29 @@
 
              ENDIF
-          !
-          !-- Read-in MDH emissions time factors
-          ELSEIF ( TRIM( time_fac_type ) == "MDH" )  THEN
-
-             !
-             !-- Update time indices      
+
+!
+!-- Read-in MDH emissions time factors
+
+          ELSEIF  ( TRIM( time_fac_type ) == "MDH" )  THEN
+
+!
+!-- Update time indices
              CALL time_default_indices( daytype_mdh, month_of_year, day_of_month,     &
                   hour_of_day, index_mm, index_dd,index_hh )
 
-             !
-             !-- Check if the index is less or equal to the temporal dimension of MDH emission files              
-             IF ( ( index_hh + index_dd + index_mm) <= SIZE( emt_att%mdh_emis_time_factor(1,:) ) )  THEN
-                !
-                !-- Read-in the correspondant time factor              
-                time_factor(:) = emt_att%mdh_emis_time_factor(:,index_mm) * emt_att%mdh_emis_time_factor(:,index_dd) *   &
-                                                                         emt_att%mdh_emis_time_factor(:,index_hh)
+!
+!-- Check if the index is less or equal to the temporal dimension of MDH emission files
+
+             IF  ( ( index_hh + index_dd + index_mm) <= SIZE( emt_att%mdh_emis_time_factor(1,:) ) )  THEN
+
+!
+!-- Read in corresponding time factor
+
+                time_factor(:) = emt_att%mdh_emis_time_factor(:,index_mm) *    &
+                                 emt_att%mdh_emis_time_factor(:,index_dd) *    &
+                                 emt_att%mdh_emis_time_factor(:,index_hh)
+
+!
+!-- Error check (MDH time factor not provided)
      
              ELSE
@@ -1061,5 +1153,8 @@
                 CALL message( 'chem_emissions_setup', 'CM0449', 2, 2, 0, 6, 0 )
 
-             ENDIF 
+             ENDIF  
+
+!
+!-- Error check (no time factor defined)
 
           ELSE
@@ -1071,177 +1166,212 @@
           ENDIF
 
-       !
-       !-- PARAMETERIZED MODE
-       ELSEIF ( TRIM( mode_emis ) == "PARAMETERIZED" )  THEN
+!
+!-- PARAMETERIZED MODE
+
+       ELSEIF ( emiss_lod == 0 )  THEN
+
+
+! for reference (ecc)
+!       ELSEIF  ( TRIM( mode_emis ) == "PARAMETERIZED" )  THEN
         
-          !
-          !-- assign constant values of time factors, diurnal time profile for traffic sector
-          par_emis_time_factor( : ) =  &
-            (/ 0.009, 0.004, 0.004, 0.009, 0.029, 0.039, 0.056, 0.053, 0.051, 0.051, 0.052, 0.055,  &
-               0.059, 0.061, 0.064, 0.067, 0.069, 0.069, 0.049, 0.039, 0.039, 0.029, 0.024, 0.019 /)
+!
+!-- assign constant values of time factors, diurnal profile for traffic sector
+
+          par_emis_time_factor( : ) =  (/ 0.009, 0.004, 0.004, 0.009, 0.029, 0.039,      &
+                                          0.056, 0.053, 0.051, 0.051, 0.052, 0.055,      &
+                                          0.059, 0.061, 0.064, 0.067, 0.069, 0.069,      &
+                                          0.049, 0.039, 0.039, 0.029, 0.024, 0.019 /)
           
-          IF ( .NOT. ALLOCATED( time_factor ) ) ALLOCATE( time_factor(1) )
-
-          !
-          !-- Get time-factor for specific hour
+          IF  ( .NOT. ALLOCATED (time_factor) )  ALLOCATE (time_factor(1))
+
+!
+!-- Get time-factor for specific hour
+
           index_hh = hour_of_day
-
           time_factor(1) = par_emis_time_factor(index_hh)
 
-       ENDIF
+       ENDIF  ! emiss_lod
 
        
-       !
-       !--  Emission distribution calculation
-
-       !
-       !-- PARAMETERIZED case
-       IF ( TRIM( mode_emis ) == "PARAMETERIZED" )  THEN
-
-          DO ispec = 1, nspec_out
-
-             !
-             !-- Units are micromoles/m**2*day (or kilograms/m**2*day for PMs)
-             emis_distribution(1,nys:nyn,nxl:nxr,ispec) = surface_csflux(match_spec_input(ispec)) *  &
-                                                           time_factor(1) * hour_to_s
+!
+!--  Emission distribution calculation
+
+!
+!-- LOD 0 (PARAMETERIZED mode)
+
+       IF  ( emiss_lod == 0 )  THEN
+
+! for reference (ecc)
+!       IF  ( TRIM( mode_emis ) == "PARAMETERIZED" )  THEN
+
+          DO ispec = 1, n_matched_vars
+
+!
+!-- Units are micromoles/m**2*day (or kilograms/m**2*day for PMs)
+
+             emis_distribution(1,nys:nyn,nxl:nxr,ispec) =            &
+                       surface_csflux(match_spec_input(ispec)) *     &
+                       time_factor(1) * hour_to_s
 
           ENDDO 
 
-       !
-       !-- PRE-PROCESSED case
-       ELSEIF ( TRIM( mode_emis ) == "PRE-PROCESSED" )  THEN
-
-          !
-          !-- Cycle over species:
-          !-- nspec_out represents the number of species in common between the emission input data
-          !-- and the chemistry mechanism used
-          DO ispec=1,nspec_out  
-    
-             emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emt(match_spec_input(ispec))%                                 &
-                                                            preproc_emission_data(index_hh,1,nys+1:nyn+1,nxl+1:nxr+1) * &
-                                                                con_factor
           
-          ENDDO
-          
-       !
-       !-- DEFAULT case
-       ELSEIF ( TRIM( mode_emis ) == "DEFAULT" )  THEN
-
-          !
-          !-- Allocate array for the emission value corresponding to a specific category and time factor
-          ALLOCATE( delta_emis(nys:nyn,nxl:nxr) )  
-
-          !
-          !-- Cycle over categories
+!
+!-- LOD 1 (DEFAULT mode)
+
+
+       ELSEIF  ( emiss_lod == 1 )  THEN
+
+! for referene (ecc)
+!       ELSEIF  ( TRIM( mode_emis ) == "DEFAULT" )  THEN
+
+!
+!-- Allocate array for the emission value corresponding to a specific category and time factor
+
+          ALLOCATE (delta_emis(nys:nyn,nxl:nxr))
+
+!
+!-- Cycle over categories
+
           DO icat = 1, emt_att%ncat
  
-             !
-             !-- Cycle over Species
-             !-- nspec_out represents the number of species in common between the emission input data
-             !-- and the chemistry mechanism used
-             DO ispec = 1, nspec_out
-
-                emis(nys:nyn,nxl:nxr) = emt(match_spec_input(ispec))%default_emission_data(icat,nys+1:nyn+1,nxl+1:nxr+1)
-
-
-                !
-                !-- NOx
-                IF ( TRIM( spc_names(match_spec_model(ispec)) ) == "NO" )  THEN
+!
+!-- Cycle over Species:  n_matched_vars represents the number of species
+!-- in common between the emission input data and the chemistry mechanism used
+
+             DO ispec = 1, n_matched_vars
+
+                emis(nys:nyn,nxl:nxr) =                    &
+                       emt(match_spec_input(ispec))%       &
+                           default_emission_data(icat,nys+1:nyn+1,nxl+1:nxr+1)
+
+!
+!-- NO 
+
+                IF  ( TRIM(spc_names(match_spec_model(ispec))) == "NO" )  THEN
                 
-                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &                 !<  kg/m2*s
-                                                  emt_att%nox_comp(icat,1) * con_factor * hour_per_day
-
-                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
-                                                                 delta_emis(nys:nyn,nxl:nxr)
-
-                ELSEIF ( TRIM( spc_names(match_spec_model(ispec)) ) == "NO2" )  THEN
-
-                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &                 !<  kg/m2*s
-                                                  emt_att%nox_comp(icat,2) * con_factor * hour_per_day
-
-                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
-                                                                 delta_emis(nys:nyn,nxl:nxr)
- 
-                !
-                !-- SOx
-                ELSEIF ( TRIM( spc_names(match_spec_model(ispec)) ) == "SO2" )  THEN
+                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) *       &         ! kg/m2/s
+                                                 time_factor(icat) *           &
+                                                 emt_att%nox_comp(icat,1) *    &
+                                                 con_factor * hour_per_day
+
+                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                &
+                               emis_distribution(1,nys:nyn,nxl:nxr,ispec) +    &
+                               delta_emis(nys:nyn,nxl:nxr)
+!
+!-- NO2
+
+                ELSEIF  ( TRIM(spc_names(match_spec_model(ispec))) == "NO2" )  THEN
+
+                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) *       &         ! kg/m2/s
+                                                 time_factor(icat) *           &
+                                                 emt_att%nox_comp(icat,2) *    &
+                                                 con_factor * hour_per_day
+
+                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                &
+                               emis_distribution(1,nys:nyn,nxl:nxr,ispec) +    &
+                               delta_emis(nys:nyn,nxl:nxr)
+ 
+!
+!-- SO2
+                ELSEIF  ( TRIM(spc_names(match_spec_model(ispec))) == "SO2" )  THEN
                   
-                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &                 !<  kg/m2*s
-                                                 emt_att%sox_comp(icat,1) * con_factor * hour_per_day
-
-                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
-                                                                 delta_emis(nys:nyn,nxl:nxr)
-
-                ELSEIF ( TRIM( spc_names(match_spec_model(ispec)) ) == "SO4" )  THEN
+                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) *       &         ! kg/m2/s
+                                                 time_factor(icat) *           &
+                                                 emt_att%sox_comp(icat,1) *    &
+                                                 con_factor * hour_per_day
+
+                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                &
+                               emis_distribution(1,nys:nyn,nxl:nxr,ispec) +    &
+                               delta_emis(nys:nyn,nxl:nxr)
+
+!
+!-- SO4
+
+                ELSEIF  ( TRIM(spc_names(match_spec_model(ispec))) == "SO4" )  THEN
+
                   
-                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &                 !<  kg/m2*s
-                                                 emt_att%sox_comp(icat,2) * con_factor * hour_per_day
-
-                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
-                                                                 delta_emis(nys:nyn,nxl:nxr)
- 
-
-                !
-                !-- PMs
-                !-- PM1
-                ELSEIF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM1" )  THEN
-
-                   !
-                   !-- Cycle over PM1 components
-                   DO i_pm_comp = 1, SIZE( emt_att%pm_comp(1,:,1) )
-
-                      delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &               !<  kg/m2*s
-                                                     emt_att%pm_comp(icat,i_pm_comp,1) * con_factor * hour_per_day 
-
-                      emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
-                                                                    delta_emis(nys:nyn,nxl:nxr)
+                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) *       &         ! kg/m2/s
+                                                 time_factor(icat) *           &
+                                                 emt_att%sox_comp(icat,2) *    &
+                                                 con_factor * hour_per_day
+
+                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                &
+                               emis_distribution(1,nys:nyn,nxl:nxr,ispec) +    &
+                               delta_emis(nys:nyn,nxl:nxr)
+ 
+
+!
+!-- PM1
+
+                ELSEIF  ( TRIM(spc_names(match_spec_model(ispec))) == "PM1" )  THEN
+
+                   DO  i_pm_comp = 1, SIZE( emt_att%pm_comp(1,:,1) )   ! cycle through components
+
+                      delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) *              &     ! kg/m2/s
+                                                    time_factor(icat) *                  &
+                                                    emt_att%pm_comp(icat,i_pm_comp,1) *  &
+                                                    con_factor * hour_per_day 
+
+                      emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                       &
+                               emis_distribution(1,nys:nyn,nxl:nxr,ispec) +              &
+                               delta_emis(nys:nyn,nxl:nxr)
+
                    ENDDO
 
-                !
-                !-- PM2.5
-                ELSEIF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM25" )  THEN
-
-                   !
-                   !-- Cycle over PM2.5 components
-                   DO i_pm_comp = 1, SIZE( emt_att%pm_comp(1,:,2) )
-
-                      delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &               !<  kg/m2*s
-                                                     emt_att%pm_comp(icat,i_pm_comp,2) * con_factor * hour_per_day 
-
-                      emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
-                                                                    delta_emis(nys:nyn,nxl:nxr)
+!
+!-- PM2.5
+
+                ELSEIF  ( TRIM(spc_names(match_spec_model(ispec))) == "PM25" )  THEN
+
+                   DO  i_pm_comp = 1, SIZE( emt_att%pm_comp(1,:,2) )   ! cycle through components
+
+                      delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) *              &     ! kg/m2/s
+                                                    time_factor(icat) *                  &
+                                                    emt_att%pm_comp(icat,i_pm_comp,2) *  &
+                                                    con_factor * hour_per_day 
+
+                      emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                       &
+                               emis_distribution(1,nys:nyn,nxl:nxr,ispec) +              &
+                               delta_emis(nys:nyn,nxl:nxr)
  
                    ENDDO
 
-                !
-                !-- PM10 
-                ELSEIF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM10" )  THEN
-
-                   !
-                   !-- Cycle over PM10 components
-                   DO i_pm_comp = 1, SIZE( emt_att%pm_comp(1,:,3) )  
-
-                      delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &               !<  kg/m2*s
-                                                     emt_att%pm_comp(icat,i_pm_comp,3) * con_factor * hour_per_day 
-
-                      emis_distribution(1,nys:nyn,nxl:nxr,ispec)=emis_distribution(1,nys:nyn,nxl:nxr,ispec)+ &
-                                                                 delta_emis(nys:nyn,nxl:nxr) 
+!
+!-- PM10
+
+                ELSEIF  ( TRIM(spc_names(match_spec_model(ispec))) == "PM10" )  THEN
+
+                   DO  i_pm_comp = 1, SIZE( emt_att%pm_comp(1,:,3) )   ! cycle through components
+
+                      delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) *              &     ! kg/m2/s
+                                                    time_factor(icat)     *              &
+                                                    emt_att%pm_comp(icat,i_pm_comp,3) *  &
+                                                    con_factor * hour_per_day 
+
+                      emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                       &
+                               emis_distribution(1,nys:nyn,nxl:nxr,ispec) +              &
+                               delta_emis(nys:nyn,nxl:nxr) 
 
                    ENDDO
 
-                !
-                !-- VOCs
-                ELSEIF ( SIZE( match_spec_voc_input ) > 0 )  THEN
-
-                   DO ivoc = 1, SIZE( match_spec_voc_input )
-
-                      IF ( TRIM( spc_names(match_spec_model(ispec)) ) == TRIM( emt_att%voc_name(ivoc) ) )  THEN    
-
-                         delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &
-                                                        emt_att%voc_comp(icat,match_spec_voc_input(ivoc)) * &
-                                                         con_factor * hour_per_day
-
-                         emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
-                                                                       delta_emis(nys:nyn,nxl:nxr) 
+!
+!-- VOCs
+
+                ELSEIF  ( SIZE( match_spec_voc_input ) > 0 )  THEN
+
+                   DO  ivoc = 1, SIZE( match_spec_voc_input )          ! cycle through components
+
+                      IF  ( TRIM(spc_names(match_spec_model(ispec))) ==                &
+                            TRIM(emt_att%voc_name(ivoc)) )  THEN    
+
+                         delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) *           &
+                                                       time_factor(icat) *               &
+                                                       emt_att%voc_comp(icat,match_spec_voc_input(ivoc)) *   &
+                                                       con_factor * hour_per_day
+
+                         emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                    &
+                               emis_distribution(1,nys:nyn,nxl:nxr,ispec) +              &
+                               delta_emis(nys:nyn,nxl:nxr) 
 
                       ENDIF                       
@@ -1249,15 +1379,18 @@
                    ENDDO
                 
-                !
-                !-- any other species
+!
+!-- any other species
+
                 ELSE
 
-                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) * time_factor(icat) * &
-                                                  con_factor * hour_per_day
- 
-                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) = emis_distribution(1,nys:nyn,nxl:nxr,ispec) + &
-                                                                 delta_emis(nys:nyn,nxl:nxr) 
-
-                ENDIF
+                   delta_emis(nys:nyn,nxl:nxr) = emis(nys:nyn,nxl:nxr) *                 &
+                                                 time_factor(icat) *                     &
+                                                 con_factor * hour_per_day
+ 
+                   emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                          &
+                               emis_distribution(1,nys:nyn,nxl:nxr,ispec) +              &
+                               delta_emis(nys:nyn,nxl:nxr) 
+
+                ENDIF  ! TRIM spc_names
                 
                 emis(:,:)= 0 
@@ -1269,120 +1402,173 @@
           ENDDO
 
-       ENDIF
+!
+!-- LOD 2 (PRE-PROCESSED mode)
+
+       ELSEIF  ( emiss_lod == 2 )  THEN
+
+! for reference (ecc)
+!       ELSEIF  ( TRIM( mode_emis ) == "PRE-PROCESSED" )  THEN
+
+!
+!-- Cycle over species: n_matched_vars represents the number of species
+!-- in common between the emission input data and the chemistry mechanism used
+
+          DO ispec = 1, n_matched_vars  
+ 
+! (ecc)   
+             emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                                &
+                       emt(match_spec_input(ispec))%                                     &
+                           preproc_emission_data(index_hh,1,nys+1:nyn+1,nxl+1:nxr+1) *   &
+                       con_factor
+
+
+!             emis_distribution(1,nys:nyn,nxl:nxr,ispec) =                                &
+!                       emt(match_spec_input(ispec))%                                     &
+!                           preproc_emission_data(index_hh,1,:,:) *   &
+!                       con_factor
+          ENDDO
+
+       ENDIF  ! emiss_lod
 
        
 !
 !-- Cycle to transform x,y coordinates to the one of surface_mod and to assign emission values to cssws
-!
-!-- PARAMETERIZED mode
-       !
-       !-- Units of inputs are micromoles/(m**2*s)
-       IF ( TRIM( mode_emis ) == "PARAMETERIZED" )  THEN
-
-          IF ( street_type_f%from_file )  THEN
-
-!
-!--          Streets are lsm surfaces, hence, no usm surface treatment required. 
-!--          However, urban surface may be initialized via default initialization
-!--          in surface_mod, e.g. at horizontal urban walls that are at k == 0
-!--          (building is lower than the first grid point). Hence, in order to 
-!--          have only emissions at streets, set the surfaces emissions to zero
-!--          at urban walls. 
-             IF ( surf_usm_h%ns >=1 )  surf_usm_h%cssws = 0.0_wp
-!
-!--          Now, treat land-surfaces.
+
+!
+!-- LOD 0 (PARAMETERIZED mode)
+!-- Units of inputs are micromoles/m2/s
+
+       IF  ( emiss_lod == 0 )  THEN
+! for reference (ecc)
+!       IF  ( TRIM( mode_emis ) == "PARAMETERIZED" )  THEN
+
+          IF  (street_type_f%from_file)  THEN
+
+!
+!-- Streets are lsm surfaces, hence, no usm surface treatment required. 
+!-- However, urban surface may be initialized via default initialization
+!-- in surface_mod, e.g. at horizontal urban walls that are at k == 0
+!-- (building is lower than the first grid point). Hence, in order to 
+!-- have only emissions at streets, set the surfaces emissions to zero
+!-- at urban walls.
+ 
+             IF  ( surf_usm_h%ns >=1 )  surf_usm_h%cssws = 0.0_wp
+
+!
+!-- Treat land-surfaces.
+
              DO  m = 1, surf_lsm_h%ns
+
                 i = surf_lsm_h%i(m)
                 j = surf_lsm_h%j(m)
                 k = surf_lsm_h%k(m)
 
-                IF ( street_type_f%var(j,i) >= main_street_id  .AND. street_type_f%var(j,i) < max_street_id )  THEN
-
-                   !
-                   !-- Cycle over matched species
-                   DO  ispec = 1, nspec_out
-
-                      !
-                      !-- PMs are already in kilograms 
-                      IF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM1 "  &
-                          .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM25"  &
-                          .OR. TRIM( spc_names(match_spec_model(ispec)) )=="PM10")  THEN
-
-                         !
-                         !--           kg/(m^2*s) * kg/m^3
-                         surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_main(match_spec_input(ispec)) * &
-                                                                        emis_distribution(1,j,i,ispec) *            &  !< in kg/(m^2*s)
-                                                                         rho_air(k)                                    !< in kg/m^3
+                IF  ( street_type_f%var(j,i) >= main_street_id    .AND.                  &
+                      street_type_f%var(j,i) < max_street_id   )  THEN
+
+!
+!-- Cycle over matched species
+
+                   DO  ispec = 1, n_matched_vars
+
+!
+!-- PMs are already in kilograms 
+
+                      IF  ( TRIM(spc_names(match_spec_model(ispec))) == "PM1"     .OR. &
+                            TRIM(spc_names(match_spec_model(ispec))) == "PM25"    .OR. &
+                            TRIM(spc_names(match_spec_model(ispec))) == "PM10" )  THEN
+
+!
+!-- kg/(m^2*s) * kg/m^3
+                         surf_lsm_h%cssws(match_spec_model(ispec),m) =                   &
+                                   emiss_factor_main(match_spec_input(ispec)) *          &
+                                   emis_distribution(1,j,i,ispec) *                      &     ! kg/(m^2*s)
+                                   rho_air(k)                                                  ! kg/m^3
                          
-                      !
-                      !-- Other Species
-                      !-- Inputs are micromoles
+!
+!-- Other Species
+!-- Inputs are micromoles
+
                       ELSE
 
-                         !   
-                         !--             ppm/s *m *kg/m^3                
-                         surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_main(match_spec_input(ispec)) * &
-                                                                        emis_distribution(1,j,i,ispec) *            &  !< in micromoles/(m^2*s)
-                                                                         conv_to_ratio(k,j,i) *                     &  !< in m^3/Nmole     
-                                                                          rho_air(k)                                   !< in kg/m^3
+!   
+!-- ppm/s *m *kg/m^3                
+                         surf_lsm_h%cssws(match_spec_model(ispec),m) =                   &
+                                   emiss_factor_main(match_spec_input(ispec)) *          &
+                                   emis_distribution(1,j,i,ispec) *                      &     ! micromoles/(m^2*s)
+                                   conv_to_ratio(k,j,i) *                                &     ! m^3/Nmole     
+                                   rho_air(k)                                                  ! kg/m^3
 
                       ENDIF
 
-                   ENDDO
-
-
-                ELSEIF ( street_type_f%var(j,i) >= side_street_id  .AND. street_type_f%var(j,i) < main_street_id )  THEN
-
-                   !
-                   !-- Cycle over matched species
-                   DO  ispec = 1, nspec_out
-
-                      !
-                      !-- PMs are already in kilograms
-                      IF ( TRIM( spc_names(match_spec_model(ispec)) ) == "PM1"  &
-                          .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM25"  &
-                          .OR. TRIM( spc_names(match_spec_model(ispec)) ) == "PM10" )  THEN
-
-                         !
-                         !--           kg/(m^2*s) * kg/m^3
-                         surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_side(match_spec_input(ispec)) * &
-                                                                        emis_distribution(1,j,i,ispec) *            &  !< in kg/(m^2*s)
-                                                                         rho_air(k)                                    !< in kg/m^3   
-                      !
-                      !-- Other species
-                      !-- Inputs are micromoles
+                   ENDDO  ! ispec
+
+
+                ELSEIF  ( street_type_f%var(j,i) >= side_street_id   .AND.               &
+                          street_type_f%var(j,i) < main_street_id )  THEN
+
+!
+!-- Cycle over matched species
+
+                   DO  ispec = 1, n_matched_vars
+
+!
+!-- PMs are already in kilograms
+
+                      IF  ( TRIM(spc_names(match_spec_model(ispec))) == "PM1"     .OR. &
+                            TRIM(spc_names(match_spec_model(ispec))) == "PM25"    .OR. &
+                            TRIM(spc_names(match_spec_model(ispec))) == "PM10" )  THEN
+
+!
+!-- kg/(m^2*s) * kg/m^3
+                         surf_lsm_h%cssws(match_spec_model(ispec),m) =                   &
+                                   emiss_factor_side(match_spec_input(ispec)) *          &
+                                   emis_distribution(1,j,i,ispec) *                      &     ! kg/(m^2*s)
+                                   rho_air(k)                                                  ! kg/m^3   
+!
+!-- Other species
+!-- Inputs are micromoles
+
                       ELSE
-                    
-                         !   
-                         !--             ppm/s *m *kg/m^3      
-                         surf_lsm_h%cssws(match_spec_model(ispec),m) = emiss_factor_side(match_spec_input(ispec)) * &
-                                                                        emis_distribution(1,j,i,ispec) *            &  !< in micromoles/(m^2*s)
-                                                                         conv_to_ratio(k,j,i) *                     &  !< in m^3/Nmole       
-                                                                          rho_air(k)                                   !< in kg/m^3   
+
+!   
+!-- ppm/s *m *kg/m^3
+
+                         surf_lsm_h%cssws(match_spec_model(ispec),m) =                   &
+                                   emiss_factor_side(match_spec_input(ispec)) *          &
+                                   emis_distribution(1,j,i,ispec) *                      &  ! micromoles/(m^2*s)
+                                   conv_to_ratio(k,j,i) *                                &  ! m^3/Nmole       
+                                   rho_air(k)                                               ! kg/m^3   
+
                       ENDIF
 
-                   ENDDO
+                   ENDDO  ! ispec
+
+!
+!-- If no street type is defined, then assign zero emission to all the species
 
                 ELSE
 
-                   !
-                   !-- If no street type is defined, then assign zero emission to all the species
                    surf_lsm_h%cssws(:,m) = 0.0_wp
 
-                ENDIF
-
-             ENDDO
-
-          ENDIF
-
-       !
-       !-- For both DEFAULT and PRE-PROCESSED mode
+                ENDIF  ! street type
+
+             ENDDO  ! m
+
+          ENDIF  ! street_type_f%from_file
+
+
+!
+!-- LOD 1 (DEFAULT) and LOD 2 (PRE-PROCESSED)
+
+
        ELSE    
        
 
-          DO ispec = 1, nspec_out 
+          DO ispec = 1, n_matched_vars 
                    
 !
 !--          Default surfaces
+
              DO  m = 1, surf_def_h(0)%ns
 
